<?php

/**
 * Namespace
 */
namespace CreoCode\ContaoFormSubmissions;
use Contao\Database;

use CreoCode\ContaoFormSubmissions\FormSubmissionsSetModel;

class Cron {

    /**
     * performs daily actions
     *
     * @return boolean
     */
    public static function dailyCron() {

		if ($_SERVER['REQUEST_URI'] === '/app_dev.php') {
		    $debug = true;
		}

        $lastRun = \Config::get('daily_run');

        // check if there is any form submission to anonimize or to delete
        if( !$lastRun || $lastRun < strtotime("-1 day") || $debug) {

	        $arrFormSets = FormSubmissionsSetModel::findAll();
	        if ($arrFormSets) {
		        foreach ($arrFormSets as $formSet) {
		        	$form = \Contao\FormModel::findById($formSet->form_id);
		        	$Database = Database::getInstance();

		            if ($form->cc_anonymise_after !== "0") {
		            	$tstampAfter = strtotime('-'.$form->cc_anonymise_after.' month', time());
		                $Database->prepare('DELETE FROM tl_form_submissions_data WHERE form_id=? AND tstamp < ?')
		                    ->execute($form->id, $tstampAfter);
		            }
		            if ($form->cc_delete_after !== "0") {
		            	$tstampAfter = strtotime('-'.$form->cc_delete_after.' month', time());
		                $Database->prepare('DELETE FROM tl_form_submissions_data WHERE form_id=? AND tstamp < ?')
		                    ->execute($form->id, $tstampAfter);
		                $Database->prepare('DELETE FROM tl_form_submissions WHERE form_id=? AND tstamp < ?')
		                    ->execute($form->id, $tstampAfter);
		            }
		        }
	        }

            \Config::persist('daily_run', time());
        }
    }
}